name: "Mutation tests"

on:
  pull_request:
  push:

jobs:
  mutation-tests:
    name: "Mutation tests"

    runs-on: ${{ matrix.operating-system }}

    strategy:
      matrix:
        dependencies:
          - "locked"
        php-version:
          - "8.2"
        operating-system:
          - "ubuntu-latest"

    steps:
      - name: "Checkout"
        uses: "actions/checkout@v4.2.2"

      - name: "Install PHP"
        uses: "shivammathur/setup-php@2.32.0"
        with:
          coverage: "xdebug"
          php-version: "${{ matrix.php-version }}"
          ini-values: memory_limit=-1
          tools: composer:v2, cs2pr

      - name: "Install dependencies"
        uses: "ramsey/composer-install@3.0.0"
        with:
          dependency-versions: "${{ matrix.dependencies }}"

      - name: "Infection"
        run: "make infection PHPUNIT_FLAGS=--coverage-clover=coverage.xml INFECTION_FLAGS=--logger-github"

      - name: "Upload Code Coverage"
        uses: "codecov/codecov-action@v5.3.1"
